import { InjectionToken, Type } from "@angular/core";
import { AuthServiceInterface } from "./auth-service.interface";
import { AuthJWTOptions } from "./jwt/jwt-utils";
import { SvwValidators } from "../world/interfaces";
export declare const SERVIW_AUTH_SERVICE: InjectionToken<AuthServiceInterface<any, any>>;
export declare const SERVIW_AUTH_OPTIONS: InjectionToken<AuthOptions>;
export declare const ValidationEmail: RegExp;
/**
 * @param username
 * @returns AuthOptions
 */
export declare const AuthOptionsDefault: (username?: string) => AuthOptions;
/**
 * Auth options
 */
export interface AuthOptions {
    service: Type<AuthServiceInterface<any>>;
    userIdentityField: string;
    validations: {
        username: SvwValidators;
        password: SvwValidators;
    };
    login: {
        path: string;
        endpoint: string;
        messageError: string;
        messageSuccess: string;
        redirectSuccess: string;
    };
    authentication: {
        endpoint: string;
        fieldInUser: string;
        messageError?: string;
        callAfterLogin: boolean;
    };
    logout?: {
        endpoint: string;
        messageError: string;
        messageSuccess?: string;
    };
    token?: AuthJWTOptions;
}
//# sourceMappingURL=auth-options.d.ts.map