import { AuthServiceInterface } from "../auth/auth-service.interface";
import * as i0 from "@angular/core";
export declare class AuthService<U> implements AuthServiceInterface<U> {
    readonly authInterface: AuthServiceInterface<U>;
    /**
     * Creates an instance of auth service.
     * @param authInterface
     */
    constructor(authInterface: AuthServiceInterface<U>);
    /** Gets auth options */
    get authOptions(): import("../auth/auth-options").AuthOptions;
    /** redirectSuccess */
    get redirectSuccess(): string;
    /**
     * Login auth service
     */
    login(data: U): Promise<U>;
    getUser(): U;
    authentication(): Promise<boolean>;
    resetUser(): void;
    isExpiredAuth(): Promise<boolean>;
    isAutenticate(): boolean;
    logout(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AuthService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AuthService<any>>;
}
//# sourceMappingURL=auth.service.d.ts.map