import { GraphqlFilters, SvwJsonGraphql } from './../world/interfaces-graphql';
import { ServiwCoreJson } from './serviw-core-json';
/**
 * Entity graphql
 * @template I Entity interface
 */
export declare class EntityGraphql<I> extends ServiwCoreJson<I> {
    readonly json: SvwJsonGraphql<I>;
    /** Schema  of entity graphql */
    readonly schema = "[GRAPHQL]";
    /** Params  of entity graphql */
    params: GraphqlFilters;
    /**
     * Creates an instance of entity graphql.
     */
    constructor(json: SvwJsonGraphql<I>);
    /**
     * Gets fields
     */
    get fields(): import("serviw-core").TypeProperties<I, import("./../world/interfaces-graphql").SvwPropertyGraphql<any>>;
    /**
     * Resets params
     */
    resetParams(): void;
    /**
     * Params default
     * @returns
     */
    paramsDefault(): {
        first: {
            type: string;
            value: number;
            validations: {
                nullable: boolean;
            };
        };
        after: {
            type: string;
            value: string;
            validations: {
                nullable: boolean;
            };
        };
    };
    /**
     * Params default
     * @param [first]
     * @param [after]
     * @returns
     */
    static paramsDefault(first?: number, after?: string): {
        first: {
            type: string;
            value: number;
            validations: {
                nullable: boolean;
            };
        };
        after: {
            type: string;
            value: string;
            validations: {
                nullable: boolean;
            };
        };
    };
    /**
     * Refactors query edges
     * @param fields
     * @returns query edges
     */
    fieldsQuery(): string;
    /**
     * Gets fields
     * @param filters
     * @returns
     */
    getFields(filters: string): string;
}
//# sourceMappingURL=entity-graphql.d.ts.map