import { LazyLoadEvent } from './../world/interfaces';
import { ServiwCoreJson } from './serviw-core-json';
import { SvwJsonRest } from '../world/interfaces-rest';
import { FiltersLoad } from '../services/serviw-rest';
/**
 * Entity rest
 */
export declare class EntityRest<I> extends ServiwCoreJson<I> {
    readonly json: SvwJsonRest<I>;
    /**
     * Schema  of entity rest
     */
    readonly schema = "[REST]";
    /**
     * Params  of entity rest
     */
    params: LazyLoadEvent;
    /**
     * Creates an instance of entity rest.
     * @param json
     */
    constructor(json: SvwJsonRest<I>);
    /**
     * Gets fields
     */
    get fields(): import("./../world/interfaces").TypeProperties<I, import("../world/interfaces-rest").SvwPropertyRest<any>>;
    /**
     * Resets params
     */
    resetParams(): void;
    /**
     * Params default
     * @returns
     */
    paramsDefault(): {
        first: number;
        filters: {
            [x: string]: string | number | boolean;
        };
    };
    /**
     * Params default
     * @param [first]
     * @param [filters]
     * @returns
     */
    static paramsDefault(first?: number, filters?: FiltersLoad): {
        first: number;
        filters: {
            [x: string]: string | number | boolean;
        };
    };
    /**
     * Fields query
     */
    fieldsQuery(): string;
    /**
     * Gets fields
     * @param filters
     * @returns
     */
    getFields(filters: string): string;
}
//# sourceMappingURL=entity-rest.d.ts.map