import { SCHEMAS } from './../world/constants';
import { CoreEntity } from '../world/schemas';
import { SvwJsonGraphql } from '../world/interfaces-graphql';
import { SvwJsonRest } from '../world/interfaces-rest';
import * as i0 from "@angular/core";
/**
 * Svw json events
 * @template I Entity interface
 */
export declare abstract class SvwJsonEvents<I> {
    readonly schema: SCHEMAS;
    /** Entity name */
    nameEntity?: string;
    /** Loading  of svw json events */
    loading: boolean;
    /** Core Entity EntityGraphql | EntityRest */
    private _entity?;
    /**
     * Creates an instance of svw json events.
     * @param schema
     */
    constructor(schema: SCHEMAS);
    /** Set entity Json */
    set json(val: SvwJsonGraphql<I> | SvwJsonRest<I>);
    /** Get Json */
    get json(): SvwJsonGraphql<I> | SvwJsonRest<I>;
    /** Get json original */
    get jsonI(): SvwJsonRest<I> | SvwJsonGraphql<I>;
    /** Get entity */
    get entity(): CoreEntity<I>;
    /** Determine whether to load the json */
    protected abstract onLoadJson(): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<SvwJsonEvents<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SvwJsonEvents<any>, "ng-component", never, { "nameEntity": "nameEntity"; "json": "json"; }, {}, never, never>;
}
//# sourceMappingURL=json-events.d.ts.map