import { SvwJsonRest, SvwPropertyRest } from './../world/interfaces-rest';
import { SvwJsonGraphql, SvwPropertyGraphql } from './../world/interfaces-graphql';
import { CoreProperty } from './../world/schemas';
import { SCHEMAS } from './../world/constants';
/**
 * Serviw core json
 */
export declare abstract class ServiwCoreJson<I> {
    protected readonly json: SvwJsonGraphql<I> | SvwJsonRest<I>;
    /** Schema  of serviw core json */
    abstract readonly schema: SCHEMAS;
    /** Valid json of svw json events */
    readonly validJson: boolean;
    /** Id  of serviw core json */
    private _id?;
    /** Core fields of serviw core json */
    private readonly _coreFields;
    /** Core fields form of serviw core json */
    private readonly _coreFieldsForm;
    /**
     * Creates an instance of serviw core json.
     */
    constructor(json: SvwJsonGraphql<I> | SvwJsonRest<I>);
    /** Params  of serviw core json */
    abstract params: any;
    /** Gets params default */
    abstract paramsDefault(): any;
    /** Gets fields */
    abstract get fields(): any;
    /** Fields query */
    abstract fieldsQuery(): any;
    /**
     * Gets fields
     */
    abstract getFields(filters: string): any;
    /** Resets params */
    abstract resetParams(): any;
    /** Emptys id */
    emptyId(data?: any): boolean;
    /** Gets id name */
    get idName(): string;
    /** Gets id */
    get id(): {
        name?: string;
        field?: CoreProperty;
        value?: any;
    };
    /** Maps fields */
    mapFields(call: (field: CoreProperty) => any): void;
    /** Gets core fields with template && displayColumn */
    get coreFields(): {
        name?: string;
        property?: CoreProperty;
    }[];
    /** Cores fields form  */
    get coreFieldsForm(): {
        name?: string;
        property?: CoreProperty;
    }[];
    /** Values properties */
    static valueProperties<I>(item: I, column: string, property?: SvwPropertyGraphql | SvwPropertyRest): "" | I;
    /** Sets value id */
    setValueId(value: I): void;
    /** Resets value id */
    resetValueId(): void;
}
//# sourceMappingURL=serviw-core-json.d.ts.map