import { CoreProperty, CoreEntity } from './../world/schemas';
import { FormGroup, AbstractControl } from '@angular/forms';
import { EventEmitter, ComponentRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class ServiwFormField {
    /**
     * Input  of serviw form field
     */
    entity?: CoreEntity<any>;
    /**
     * Determines whether data
     */
    private __data;
    /**
     * Datos de cada campo en formulario
     */
    field?: CoreProperty;
    /**
     * Eventos click template actions
     */
    onClicks?: EventEmitter<string>;
    /**
     * Component ref of serviw form field
     */
    componentRef?: ComponentRef<ServiwFormField>;
    /**
     * Local  of serviw form field
     */
    protected local: boolean;
    /**
     * Id  of serviw form field
     */
    private id?;
    /**
     * Creates an instance of serviw form field.
     */
    constructor();
    /**
     * Gets field
     */
    get property(): import("serviw-core").SvwPropertyGraphql<any> | import("serviw-core").SvwPropertyRest<any>;
    /**
     * Gets field name
     */
    get fieldName(): string;
    /**
     * Sets input
     */
    set formGroup(val: FormGroup);
    /**
     * Gets form group
     */
    get formGroup(): FormGroup;
    /**
     * Gets control
     */
    get control(): AbstractControl | undefined;
    /**
     * Gets class label
     */
    get classLabel(): "required" | "";
    /**
     * Gets placeholder label
     */
    get placeholderLabel(): string | import("serviw-core").SvwJsonGraphql<any, any> | import("serviw-core").SvwJsonRest<any, any>;
    /**
     * Gets item display
     */
    get itemDisplay(): (value: any) => string;
    /**
     * Comparar objetos por id, recomendado para template <select [compareWith]="compareFn"
     * @param item1
     * @param item2
     * @returns true if item1 == item2
     */
    compareFn(item1: any, item2: any): boolean;
    /**
     * Inits on clicks
     */
    protected initOnClicks(): void;
    /**
     * Submits form
     */
    submitForm(): void;
    /**
     * Gets data view
     */
    get dataView(): string | number | undefined;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwFormField, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ServiwFormField, "[libServiwFormField]", never, { "entity": "entity"; "field": "field"; "formGroup": "formGroup"; }, { "onClicks": "onClicks"; }, never>;
}
//# sourceMappingURL=serviw-form.field.d.ts.map