import { ServiwQueryService } from './../services/serviw-query.service';
import { ServiwFormField } from './../classes/serviw-form.field';
import { OnInit, ChangeDetectorRef, OnDestroy, Renderer2 } from '@angular/core';
import { ViewContainerRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class ServiwFormDirective extends ServiwFormField implements OnInit, OnDestroy {
    viewContainerRef: ViewContainerRef;
    serviwQueryService: ServiwQueryService;
    cd: ChangeDetectorRef;
    private renderer2;
    /**
     * Reset options of serviw form directive
     */
    resetOptions?: boolean;
    /**
     * Timeout  of serviw form directive
     */
    private timeout?;
    /**
     * Config  of serviw form directive
     */
    private readonly config;
    /**
     * Creates an instance of serviw form directive.
     * @param viewContainerRef
     * @param serviwQueryService
     * @param cd
     */
    constructor(viewContainerRef: ViewContainerRef, serviwQueryService: ServiwQueryService, cd: ChangeDetectorRef, renderer2: Renderer2);
    /**
     * after content init
     *
     * @description Inicializar ajustes de cada plantilla (campos de formulario)
     */
    ngOnInit(): void;
    /**
     * Loads template
     * @returns true if template
     */
    private loadTemplate;
    /**
     * Gets template
     */
    private get template();
    /**
     * Updates component ref
     * @param [changes]
     */
    private updateComponentRef;
    /**
     * Loads call backs
     */
    private loadCallBacks;
    /**
     * Valids options
     * @deprecated
     */
    private validOptions;
    /**
     * Loads autocomplete
     * @deprecated
     */
    private loadAutocomplete;
    /**
     * Loads options, consulta opciones para select del servidor
     * @deprecated
     * @returns options
     */
    private loadOptions;
    /**
     * on destroy
     */
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwFormDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<ServiwFormDirective, "[libServiwForm]", never, {}, {}, never>;
}
//# sourceMappingURL=serviw-form.directive.d.ts.map