import { ElementRef, OnInit, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare const INPUTNUMBER_VALUE_ACCESSOR: any;
/**
 * Directive
 * @see [github] https://github.com/primefaces/primeng/blob/master/src/app/components/inputnumber/inputnumber.ts
 * @see [primeng] https://www.primefaces.org/primeng/showcase/#/inputnumber
 */
export declare class InputNumber implements OnInit, ControlValueAccessor {
    showButtons: boolean;
    format: boolean;
    buttonLayout: string;
    prefix?: string;
    locale?: string;
    suffix?: string;
    localeMatcher?: string;
    currency?: string;
    currencyDisplay?: string;
    useGrouping: boolean;
    disabled?: boolean;
    inputId?: string;
    styleClass?: string;
    placeholder?: string;
    size?: number;
    maxlength?: number;
    tabindex?: string;
    title?: string;
    ariaLabel?: string;
    ariaRequired?: boolean;
    name?: string;
    required?: boolean;
    autocomplete?: string;
    min?: number;
    max?: number;
    minFractionDigits?: number;
    maxFractionDigits?: number;
    precision?: string;
    incrementButtonClass?: string;
    decrementButtonClass?: string;
    incrementButtonIcon: string;
    decrementButtonIcon: string;
    mode: string;
    step: number;
    input: ElementRef;
    onFocus: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    value?: number;
    onModelChange: Function;
    onModelTouched: Function;
    focused?: boolean;
    isSpecialChar?: boolean;
    timer: any;
    lastValue?: string;
    _numeral: any;
    numberFormat: any;
    _decimal: any;
    _group: any;
    _minusSign: any;
    _currency: any;
    _prefix: any;
    _suffix: any;
    _index: any;
    constructor(el: ElementRef);
    ngOnInit(): void;
    formatValue(value: number): string | number;
    formattedValue(): string | number;
    onInput(event: any): void;
    onInputKeyDown(event: any): void;
    onInputKeyPress(event: KeyboardEvent): void;
    onPaste(event: ClipboardEvent): void;
    onInputClick(): void;
    onInputFocus(event: InputEvent): void;
    onInputBlur(event: InputEvent): void;
    onUpButtonMouseDown(event: MouseEvent): void;
    onUpButtonMouseUp(): void;
    onUpButtonMouseLeave(): void;
    onUpButtonKeyDown(event: KeyboardEvent): void;
    onUpButtonKeyUp(): void;
    onDownButtonMouseDown(event: MouseEvent): void;
    onDownButtonMouseUp(): void;
    onDownButtonMouseLeave(): void;
    onDownButtonKeyUp(): void;
    onDownButtonKeyDown(event: KeyboardEvent): void;
    spin(event: any, dir: any): void;
    repeat(event: any, interval: any, dir: any): void;
    clearTimer(): void;
    insert(event: any, text: string): void;
    /**
 * Precisions value
 * @param newValueStr
 * @returns value
 */
    private precisionValue;
    insertText(value: string, text: string, start: number, end: number): string;
    initCursor(): void;
    updateInput(value: string, operation: string): void;
    updateModel(event: any, value: number): void;
    updateValue(event: any, valueStr: string, operation: string): void;
    deleteRange(value: string, start: number, end: number): string;
    isWithinRange(value: number): boolean;
    isNumeralChar(char: string): boolean;
    isMinusSign(char: string): boolean;
    parseValue(text: string): number;
    writeValue(value: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    getOptions(): {
        localeMatcher: string;
        style: string;
        currency: string;
        currencyDisplay: string;
        useGrouping: boolean;
        minimumFractionDigits: number;
        maximumFractionDigits: number;
    };
    getDecimalExpression(): RegExp;
    getGroupingExpression(): RegExp;
    getMinusSignExpression(): RegExp;
    getCurrencyExpression(): RegExp;
    filled(): boolean;
    resetRegex(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<InputNumber, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<InputNumber, "[inputNumber]", never, { "showButtons": "showButtons"; "format": "format"; "buttonLayout": "buttonLayout"; "prefix": "prefix"; "locale": "locale"; "suffix": "suffix"; "localeMatcher": "localeMatcher"; "currency": "currency"; "currencyDisplay": "currencyDisplay"; "useGrouping": "useGrouping"; "disabled": "disabled"; "inputId": "inputId"; "styleClass": "styleClass"; "placeholder": "placeholder"; "size": "size"; "maxlength": "maxlength"; "tabindex": "tabindex"; "title": "title"; "ariaLabel": "ariaLabel"; "ariaRequired": "ariaRequired"; "name": "name"; "required": "required"; "autocomplete": "autocomplete"; "min": "min"; "max": "max"; "minFractionDigits": "minFractionDigits"; "maxFractionDigits": "maxFractionDigits"; "precision": "precision"; "incrementButtonClass": "incrementButtonClass"; "decrementButtonClass": "decrementButtonClass"; "incrementButtonIcon": "incrementButtonIcon"; "decrementButtonIcon": "decrementButtonIcon"; "mode": "mode"; "step": "step"; }, { "onFocus": "onFocus"; "onBlur": "onBlur"; }, never>;
}
export declare class InputNumberModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<InputNumberModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<InputNumberModule, [typeof InputNumber], [typeof i1.CommonModule], [typeof InputNumber]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<InputNumberModule>;
}
//# sourceMappingURL=serviw-input-number.directive.d.ts.map