import { ServiwGrowl } from './../../services/serviw-growl.service';
import { ChangeDetectorRef, EventEmitter, AfterContentInit, OnDestroy } from '@angular/core';
import { SvwBeforeSave, SvwAfterSave } from '../../world/interfaces';
import { ServiwFormService } from '../../services/serviw-form.service';
import { ServiwQueryService } from '../../services/serviw-query.service';
import { SvwJsonEvents } from '../../classes/json-events';
import { ServiwForm } from '../../services/serviw-builder.service';
import * as i0 from "@angular/core";
/**
 * Serviw core form
 */
export declare class ServiwCoreForm<I> extends SvwJsonEvents<I> implements AfterContentInit, OnDestroy {
    protected serviwGrowl: ServiwGrowl;
    protected serviwQueryService: ServiwQueryService;
    protected serviwForm: ServiwFormService;
    protected cd: ChangeDetectorRef;
    /** Input  of serviw form component */
    queryKey: boolean;
    /** show message after saving */
    showMessageAfterSaving: boolean;
    /** Event on beforeSave */
    beforeSave: EventEmitter<SvwBeforeSave<I>>;
    /** Event on submitForm */
    afterSave: EventEmitter<SvwAfterSave<I>>;
    /** onLoadForm form ServiwForm<I> */
    onLoadForm: EventEmitter<ServiwForm<I>>;
    /** FormGroup */
    formGroup?: ServiwForm<I>;
    /** Create  of serviw form component */
    private create;
    /** Value  of serviw form component */
    private _value?;
    constructor(serviwGrowl: ServiwGrowl, serviwQueryService: ServiwQueryService, serviwForm: ServiwFormService, cd: ChangeDetectorRef);
    /**
     * Input  of serviw form component
     */
    set value(data: I);
    /**
     * Gets value
     */
    get value(): I;
    /**
     * Gets call on after save
     */
    private get callOnAfterSave();
    /**
     * Determines whether load json on
     */
    onLoadJson(): void;
    /**
     * after content init
     */
    ngAfterContentInit(): void;
    /**
     * Updates create
     */
    private updateCreate;
    /**
     * Querys single
     */
    private querySingle;
    /**
     * Views form
     */
    viewForm(): void;
    /**
     * Determines whether submit on
     * @param event
     */
    onSubmit(event: any): void;
    /**
     * Resibe eventos on click de las acciones del formulaio
     *
     * 1. Evento para guardar, Define función a emitir
     * @param event
     */
    saveEvent(): void;
    /**
     * Guardar datos de un formulario
     *
     * 1. loading true, define esquema de los datos
     * 2. Callbacks, del servidor
     *  2.1.1. Actualizar formulario, loading false
     *  2.2.1.
     */
    private save;
    /**
     * on destroy
     */
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwCoreForm<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ServiwCoreForm<any>, "ng-component", never, { "queryKey": "queryKey"; "showMessageAfterSaving": "showMessageAfterSaving"; "value": "value"; }, { "beforeSave": "beforeSave"; "afterSave": "afterSave"; "onLoadForm": "onLoadForm"; }, never, never>;
}
//# sourceMappingURL=serviw-core-form.d.ts.map