import { ServiwGrowl } from './../../services/serviw-growl.service';
import { AfterContentInit, EventEmitter } from '@angular/core';
import { ServiwQueryService } from '../../services/serviw-query.service';
import { SvwFilterTable, FilterTable, RefactorQuery, SvwProperty } from '../../world/interfaces';
import { ServiwEvents } from '../../services/serviw-events.service';
import { SvwJsonEvents } from '../../classes/json-events';
import { ServiwForm } from '../../services/serviw-builder.service';
import * as i0 from "@angular/core";
export declare abstract class ServiwCoreTable<I> extends SvwJsonEvents<I> implements AfterContentInit {
    protected serviwQuery: ServiwQueryService;
    protected serviwEvents: ServiwEvents;
    protected serviwGrowl: ServiwGrowl;
    /**
     * Output  of serviw core table
     */
    onSelect: EventEmitter<I>;
    /**
     * Output  of serviw core table
     */
    onChangeData: EventEmitter<I[]>;
    /**
     * Output  of serviw core table
     */
    onFilter: EventEmitter<FilterTable<any>>;
    /**
     * Output  of serviw core table
     */
    onDelete: EventEmitter<I | null>;
    /**
     * Input  of serviw core table
     */
    lazy: boolean;
    /**
     * Row select of serviw core table
     */
    rowSelect: I;
    /**
     * Data  of serviw core table
     */
    data: I[];
    /**
     * Form filters of serviw core table
     * @nullable
     */
    formFilters?: ServiwForm<I>;
    /**
     * Determines whether check on
     */
    private _onCheck;
    /**
     * Time filter of serviw core table
     */
    private timeFilter?;
    /**
     * Creates an instance of serviw core table.
     * @param serviwQuery
     * @param serviwEvents
     */
    constructor(serviwQuery: ServiwQueryService, serviwEvents: ServiwEvents, serviwGrowl: ServiwGrowl);
    /**
     * Determines whether load json on
     */
    protected onLoadJson(): void;
    /**
    * after content init
    */
    ngAfterContentInit(): void;
    /**
     * Loads form filters
     */
    protected loadFormFilters(): void;
    /**
     * Filters serviw core table
     */
    filterTable(): void;
    /**
     * Resets filters
     */
    resetFilters(): void;
    /**
     * Updates filters
     */
    protected updateFilters(): void;
    /**
     * Filters field
     * @param property
     */
    protected filterField(key: string, property: SvwProperty): void;
    /**
     * Filters table
     * @param filter
     * @returns table
     * @deprecated
     */
    setFilterTable(filter: SvwFilterTable): void;
    /**
     * Sets data
     * @param vals
     */
    setData(vals: I[]): void;
    /**
     * Determines whether row select on
     * @param row
     */
    onRowSelect(row?: I): void;
    /**
     * Updates serviw core table component
     */
    update(item?: I | []): void;
    /**
     * Updates data
     * @returns
     */
    updateData(): Promise<any>;
    /**
     * Gets data
     * @returns Promise | null
     */
    getData(): Promise<any> | null;
    /**
     * Disables filters
     * @param value
     */
    disableFilters(value: boolean): void;
    /**
     * Determines whether get data on
     * @param response
     * @param query
     */
    protected abstract onGetData(response: any, query: RefactorQuery): I;
    /**
     * Removes ite
     */
    deleteItem(): Promise<any>;
    /**
     * Emits check
     * @param [empty]
     * @returns true if check
     */
    emitCheck(empty?: boolean): boolean;
    /**
     * Rows equals
     * @param row
     * @returns equals
     */
    rowEquals(row: any): string;
    /**
     * Gets whether on check
     */
    get onCheck(): import("rxjs").Observable<I>;
    /**
     * Gets whether in check
     */
    get inCheck(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwCoreTable<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ServiwCoreTable<any>, "ng-component", never, { "lazy": "lazy"; }, { "onSelect": "onSelect"; "onChangeData": "onChangeData"; "onFilter": "onFilter"; "onDelete": "onDelete"; }, never, never>;
}
//# sourceMappingURL=serviw-core-table.d.ts.map