import { FormGroup, FormBuilder, FormControl, ValidatorFn, AsyncValidatorFn } from "@angular/forms";
import { Subscription } from 'rxjs';
import { CoreEntity } from '../world/schemas';
import { ServiwControl } from '../classes/serviw-control';
import * as i0 from "@angular/core";
declare type Types = [any] | [any, ValidatorFn] | [any, ValidatorFn, AsyncValidatorFn];
export declare class ServiwBuilder extends FormBuilder {
    /**
     * Params serviw builder
     * @param controlsConfig
     * @param [extra]
     * @description [any => value, ValidatorFn => validations, AsyncValidatorFn => validations async]
     * @description Types => [] | [any] | [any, ValidatorFn] | [any, ValidatorFn, AsyncValidatorFn]
     * @returns group FormGroup
     */
    group<I>(controlsConfig: {
        [P in keyof I]: Types;
    }, extra?: {
        [key: string]: any;
    } | null): ServiwForm<I>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwBuilder, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ServiwBuilder>;
}
/**
 * Serviw form
 * I -> interface
 */
export declare class ServiwForm<I> extends FormGroup {
    /**
     * Subscription  of serviw form
     */
    subscription: Subscription;
    /**
     * Entity  of serviw form
     */
    readonly entity: CoreEntity<I>;
    constructor(controls: {
        [P in keyof I]: FormControl | ServiwControl;
    }, entity?: CoreEntity<I>, subscription?: Subscription);
    /**
     * Unsubscribe this.subscription form
     */
    unsubscribeControls(): void;
}
/**
 * Serviw abstract control
 */
export declare class ServiwFormControl extends FormControl {
    readonly errors: {
        detail?: string;
        required?: any;
        notRequired?: any;
        minlength?: any;
        maxlength?: any;
        max?: any;
        min?: any;
        exists?: any;
        errorExists?: any;
        pattern?: any;
        other?: any;
        email?: any;
        unique?: any;
    } | null;
}
export {};
//# sourceMappingURL=serviw-builder.service.d.ts.map