import { SvwMessage } from '../world/interfaces';
import * as i0 from "@angular/core";
export declare class ServiwGrowl {
    /**
     * Messages  of serviw growl
     */
    readonly messages: SvwMessage[];
    /**
     * All messages of serviw growl
     */
    readonly allMessages: SvwMessage[];
    /**
     * Sidebar  of serviw growl
     */
    sidebar: boolean;
    /**
     * Messages sub of serviw growl
     */
    private messagesSub;
    /**
     * Icons  of serviw growl
     */
    private readonly icons;
    /**
     * Creates an instance of serviw growl.
     */
    constructor();
    /**
     * Sets icons
     * @param icons
     */
    setIcons(icons: {
        success?: string;
        info?: string;
        error?: string;
        warn?: string;
    }): void;
    /**
     * Subscribes serviw growl
     * @returns
     */
    get events(): import("rxjs").Observable<SvwMessage>;
    /**
      ** Visualizar u ocultal mensajes de la barra lateral
      */
    displayMessages(): void;
    /**
     * Eliminar un mensaje al asignarse el index, o resetear la lista
     *
     * @param i Index mensaje en array
     */
    clear(i?: number): void;
    /**
     * * Agregar nuevo mensaje
     * @param message
     */
    addMessage(message: SvwMessage): void;
    /**
     * * Visualizar un mensaje
     * @param message
     */
    show(message: SvwMessage): void;
    /**
     * Success serviw growl
     * @param summary
     * @param detail
     */
    success(summary: string, detail: string, duration?: number): void;
    /**
     * Adds success
     * @param summary
     * @param detail
     */
    addSuccess(summary: string, detail: string, duration?: number): void;
    /**
     * Infos serviw growl
     * @param summary
     * @param detail
     */
    info(summary: string, detail?: string, duration?: number): void;
    /**
     * Adds info
     * @param summary
     * @param detail
     */
    addInfo(summary: string, detail: string, duration?: number): void;
    /**
     * Errors message request
     * @param error
     * @param [summary]
     * @returns message request
     */
    infoMessageRequest<I>(error: Response, summary?: string): I;
    /**
     * Errors serviw growl
     * @param summary
     * @param detail
     */
    error(summary: string, detail?: string, duration?: number): void;
    /**
     * Adds error
     * @param summary
     * @param detail
     */
    addError(summary: string, detail: string, duration?: number): void;
    /**
     * Warns serviw growl
     * @param summary
     * @param detail
     */
    warn(summary: string, detail: string, duration?: number): void;
    /**
     * Adds warn
     * @param summary
     * @param detail
     */
    addWarn(summary: string, detail: string, duration?: number): void;
    /**
     * Errors message request
     * @param error
     * @param [summary]
     * @returns message request
     */
    errorMessageRequest<I>(error: Response, summary?: string): I;
    /**
     * Errors message
     * @param error
     * @returns message
     */
    errorMessage(error: any): any;
    /**
     * Saved correctly
     */
    savedCorrectly(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwGrowl, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ServiwGrowl>;
}
//# sourceMappingURL=serviw-growl.service.d.ts.map