import { JsonStorage, TypeOfType, JsonStorageSchema } from '../world/interfaces';
import { ServiwRest } from './serviw-rest';
import { ServiwGrowl } from './serviw-growl.service';
import { InjectionToken } from "@angular/core";
import * as i0 from "@angular/core";
export declare const JSON_STORAGE: InjectionToken<TypeOfType<any>>;
export declare class ServiwJsonStorage<S extends JsonStorageSchema<S>> {
    private serviwRest;
    private serviwGrowl;
    /**
     * Loading  of json storage service
     */
    private loading;
    /**
     * Determines whether load data on
     */
    private _onLoad;
    /**
     * Promise  of serviw json storage
     */
    private promise?;
    constructor(serviwRest: ServiwRest, serviwGrowl: ServiwGrowl);
    /**
     * Gets storage
     */
    get data(): JsonStorage<S>;
    /**
     * Gets whether is valid
     */
    get isValid(): boolean;
    /**
     * Sets storage
     * @template S Storage
     * @param data
     */
    setStorage<S>(data: TypeOfType<S>): void;
    /**
     * Loads json storage service
     * @param [path] = serviw/schema
     * @param [concatApi] = true
     */
    load(path?: string, concatApi?: boolean): Promise<S>;
    /**
     * Load storage
     * @param url
     */
    private loadStorage;
    /**
     * Gets whether on load
     */
    get onLoad(): import("rxjs").Observable<S>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwJsonStorage<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ServiwJsonStorage<any>>;
}
//# sourceMappingURL=serviw-json-storage.service.d.ts.map