import { FormGroup } from '@angular/forms';
import { RefactorQuery } from './../world/interfaces';
import { CoreEntity } from './../world/schemas';
import { ServiwGraphqlService } from './serviw-graphql.service';
import { SettingsServiwCore } from './settings-serviw-core';
import { QuerySingle } from '../world/interfaces';
import { EntitySave } from '../world/interfaces-graphql';
import * as i0 from "@angular/core";
export declare class ServiwQueryService {
    settings: SettingsServiwCore;
    graphql: ServiwGraphqlService;
    /**
     * Creates an instance of serviw query service.
     * @param settings
     * @param serviwGraphql
     */
    constructor(settings: SettingsServiwCore, graphql: ServiwGraphqlService);
    /**
     * Querys single
     * @param entity
     * @returns single
     */
    querySingle<I>(entity: CoreEntity<I>): QuerySingle<I>;
    /**
     * Gets data
     * @param entity
     */
    getData<I>(entity: CoreEntity<I>): RefactorQuery;
    /**
     * Delete item
     * @param entity
     * @returns query
     */
    deleteItem<I>(entity: CoreEntity<I>, item: I): QuerySingle<I>;
    /**
     * Gets query data rest
     * @param entity
     * @returns query data rest
     */
    private getQueryDataRest;
    /**
     * Querys save
     *
     * Define data query for schema
     *
     * 1. Define functions response
     * 2. Callback update Form
     * 3. Data for schema Graphql
     * 4. Data for schema REST-POST
     *
     * @param entity Entity
     * @param formGroup FormGroup
     * @returns EntitySave
     */
    querySave<I>(entity: CoreEntity<I>, formGroup: FormGroup): EntitySave;
    /**
     * Gets query save rest
     * @returns query save rest
     */
    private getQuerySaveRest;
    static ɵfac: i0.ɵɵFactoryDeclaration<ServiwQueryService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ServiwQueryService>;
}
//# sourceMappingURL=serviw-query.service.d.ts.map