import { NgModule, ComponentFactoryResolver } from '@angular/core';
import { SvwFormTemplates, SvwTableTemplate } from '../world/interfaces';
import { CoreHttpOptions } from './serviw-rest';
import { SCHEMAS } from '../world/constants';
import * as i0 from "@angular/core";
/**
 * Settings scheme
 */
export interface SettingsScheme {
    api: string;
    /** @default 'api/graphql' */
    endpointGraphql?: string;
    scheme: SCHEMAS;
    entityFieldSave?: boolean;
    nameApp: string;
}
interface Config {
    formTemplate: SvwFormTemplates;
    settingsScheme: SettingsScheme;
    ngModule?: NgModule;
    resolver: ComponentFactoryResolver;
    options: CoreHttpOptions;
    tableTemplate?: SvwTableTemplate;
}
export declare class SettingsServiwCore {
    resolver: ComponentFactoryResolver;
    /**
     * Config  of settings serviw core
     */
    private _config;
    /**
     * Set config of settings serviw core
     */
    private _setConfig;
    /**
     * Creates an instance of settings serviw core.
     * @param resolver
     */
    constructor(resolver: ComponentFactoryResolver);
    /**
     * Gets whether on update
     */
    get onUpdate(): import("rxjs").Observable<Config>;
    /**
     * Gets form template
     */
    get formTemplate(): SvwFormTemplates;
    /**
     * Sets form template
     */
    set formTemplate(components: SvwFormTemplates);
    /**
     * Gets ng module
     */
    get ngModule(): NgModule;
    /**
     * Sets ng module
     */
    set ngModule(ngModule: NgModule);
    /**
     * Sets base url
     */
    set baseUrl(data: SettingsScheme);
    /**
     * Gets base url
     */
    get API(): string;
    /**
     * Gets api graphql
     */
    get API_GRAPHQL(): string;
    /**
     * Gets name app
     */
    get NAME_APP(): string;
    /**
     * Gets scheme
     */
    get scheme(): SCHEMAS;
    /**
     * Gets entity field save
     */
    get entityFieldSave(): boolean;
    /**
     * Sets http options
     */
    set httpOptions(val: CoreHttpOptions);
    /**
     * Gets http options
     */
    get httpOptions(): CoreHttpOptions;
    /**
     * Gets table template
     */
    get tableTemplate(): SvwTableTemplate;
    /**
     * Sets table template
     */
    set tableTemplate(val: SvwTableTemplate);
    /**
     * Emits config
     */
    private emitConfig;
    static ɵfac: i0.ɵɵFactoryDeclaration<SettingsServiwCore, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SettingsServiwCore>;
}
export {};
//# sourceMappingURL=settings-serviw-core.d.ts.map