import { EntityGraphql } from '../classes/entity-graphql';
import { EntityRest } from '../classes/entity-rest';
import { SvwPropertyGraphql } from './interfaces-graphql';
import { SvwPropertyRest } from './interfaces-rest';
export declare type CoreEntity<I> = EntityRest<I> | EntityGraphql<I>;
/**
 * Core property
 */
export declare class CoreProperty {
    property: SvwPropertyGraphql | SvwPropertyRest;
    nameField: string;
    schema: string;
    loading: boolean;
    label: string;
    inputType: string;
    readonly: boolean;
    options: any;
    constructor(entity: SvwPropertyGraphql | SvwPropertyRest);
}
/**
 * Svw property graphql
 */
export declare class CorePropertyGraphql extends CoreProperty {
    readonly nameField: string;
    readonly property: SvwPropertyGraphql;
    constructor(nameField: string, property: SvwPropertyGraphql);
}
/**
 * Svw property rest
 */
export declare class CorePropertyRest extends CoreProperty {
    readonly nameField: string;
    readonly property: SvwPropertyRest;
    constructor(nameField: string, property: SvwPropertyRest);
}
//# sourceMappingURL=schemas.d.ts.map